package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.generated.managed.Receipt;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("TokenIssuerProof")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class TokenIssuerProof implements Marshallable {
	private CreateToken transaction;
	private Receipt receipt;

    //
	public CreateToken getTransaction() {
	    return transaction;
	}
	public void setTransaction(final CreateToken value) {
	    this.transaction = value;
	}

	public TokenIssuerProof transaction(final CreateToken value) {
	    setTransaction(value);
	    return this;
	}
	public Receipt getReceipt() {
	    return receipt;
	}
	public void setReceipt(final Receipt value) {
	    this.receipt = value;
	}

	public TokenIssuerProof receipt(final Receipt value) {
	    setReceipt(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.transaction == null)) {
            marshaller.writeValue(1, transaction);
        }
        if (!(this.receipt == null)) {
            marshaller.writeValue(2, receipt);
        }
        return marshaller.array();
    }
}
